local mod = RW:Boss("Deathbringer Saurfang", "Icecrown Citadell", "Icecrown Citadell", "The Entryway")
local L

-- 3.3?
if not QueryQuestsCompleted then return end

---------------------------
-- Variables
local tAddsCD, wAdds
local tRendDur, iRend, mRend
local mMark, wMarkSoon
local wFrenzy, tFrenzyCD

---------------------------
-- Init

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		L.name = "Deathbringer Saurfang"
		
		L.blood_opt = "Blood Power \"health\" frame"
		L.blood = "Blood Power"
		
		L.mark_soon = GetSpellInfo(72293) .." soon"
		L.mark_soon_opt = "Warning at 90 stacks"
	end
	L = mod:GetLocale()
	self.L = L
	
	self:SetTrigger(72173)
	self:SetWin()
	
	self:AddBoolOption("BloodPFrame", L.blood_opt, nil, nil, select(3, GetSpellInfo(72370)))
	
	tAddsCD		= self:CDTimer(30, 72173)
	tRendDur	= self:DurTargetTimer(18, 70309)
	tFrenzyCD	= self:CDTimer(30, 72737)
	
	wAdds		= self:Warning(72173)
	wMarkSoon	= self:CustomWarning({L.mark_soon, L.mark_soon_opt}, 72293)
	wFrenzy		= self:Warning(72737)
	
	mRend		= self:TargetMessage(70309)
	mMark		= self:TargetMessage(72293)
	
	iRend		= self:Icon("CIRCLE", 70309, false)
end

---------------------------
-- Locals
local bloodStacks

local function updateBlood()
	return bloodStacks, 100
end

---------------------------
-- Start

function mod:OnEngage(trigger)
	self:Track("Adds", 72173, 72357, 72356, 72358, 72172)
	self:Track("Rend", 70309)
	self:Track("Mark", 72254, 72280, 72293, 72444, 72445, 72279, 72260, 72278, 72255, 72256, 72446)
	self:Track("BloodPower", 72370, 72371)
	self:Track("Frenzy", 72737)
	
	bloodStacks = 0
	
	if self.db.profile.BloodPFrame then
		self:SendMessage("RW_AddHealthFrame", updateBlood, L.blood, select(3, GetSpellInfo(72370)), "STACK")
	end
	
	tAddsCD:Start()
	tFrenzyCD:Start()
end

function mod:Adds(event, args)
	if event == "SPELL_CAST_SUCCESS" then
		tAddsCD:Start()
		wAdds:Show()
	end
end

function mod:Rend(event, args)
	if event == "SPELL_AURA_APPLIED" then
		mRend:Show(args.dName)
		tRendDur:Start(args.dName)
		iRend:Show(args.dName)
		
	elseif event == "SPLL_AURA_REMOVED" then
		iRend:Hide(args.dName)
	end
end

function mod:Mark(event, args)
	if event == "SPELL_AURA_APPLIED" then
		mMark:Show(args.dName)
	end
end

function mod:BloodPower(event, args)
	if event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_APPLIED_DOSE" then
		bloodStacks = args.amount or 1
		
		if args.amount == "90" then
			wMarkSoon:Show()
		end
	end
end

function mod:Frenzy(event, args)
	if event == "SPELL_AURA_APPLIED" then
		tFrenzyCD:Start()
		wFrenzy:Show()
	end
end